SystemOrganization addCategory: #'Feivel-Maze'!

Object subclass: #FeivelItem
	instanceVariableNames: 'label duration speed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelItem commentStamp: 'MKaiser 6/28/2016 14:33' prior: 0!
Base Item which has no effekt.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	duration:	duration of the effct of the item
	label:		label which is displayed in the maze
	speed:		change in speed of the mouse
!

FeivelItem subclass: #FeivelCheeseItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelCheeseItem commentStamp: 'MKaiser 6/28/2016 14:34' prior: 0!
This Item represents the cheese and if the mouse pics it up, then the corresponding player is a winner.!

!FeivelCheeseItem methodsFor: 'as yet unclassified' stamp: 'Hurli 6/23/2016 14:59'!
initialize
	"comment stating purpose of message"

	super initialize.
	label := 'k'.! !

!FeivelCheeseItem methodsFor: 'as yet unclassified' stamp: 'Hurli 6/23/2016 14:53'!
takeEffekt: mouse
	"comment stating purpose of message"

	mouse foundCheese.! !

FeivelItem subclass: #FeivelEmptyItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelEmptyItem commentStamp: 'MKaiser 6/28/2016 14:35' prior: 0!
The empty item is a placeholder for each cell where no item is.!

!FeivelEmptyItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:35'!
initialize
	"comment stating purpose of message"
	super initialize.
	label := ''.! !

FeivelItem subclass: #FeivelFasterItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelFasterItem commentStamp: 'MKaiser 6/28/2016 14:35' prior: 0!
Item with the effect that the mouse moves faster.!

!FeivelFasterItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/19/2016 00:14'!
initialize
	"comment stating purpose of message"

	super initialize.
	label:= 'f'.
	duration := 20.
	speed := 2.! !

!FeivelItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 15:23'!
getLabel
	"comment stating purpose of message"

	^label! !

!FeivelItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:47'!
initialize
	"comment stating purpose of message"

	label := ''.
	speed := 1.
	duration := -1.
	! !

!FeivelItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 15:22'!
setLabel: lab
	"comment stating purpose of message"

	label := lab.! !

!FeivelItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:34'!
takeEffekt: mouse
	"comment stating purpose of message"

	duration > 0
		ifTrue: [ mouse setSpeedEffekt: speed for: duration. ].! !

FeivelItem subclass: #FeivelReturnItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelReturnItem commentStamp: 'MKaiser 6/28/2016 14:36' prior: 0!
Item that lets the mouse turn around and continue in the other direction!

!FeivelReturnItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/19/2016 00:12'!
initialize
	"comment stating purpose of message"

	super initialize.
	label := 'r'.! !

!FeivelReturnItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:54'!
takeEffekt: mouse
	"comment stating purpose of message"

	mouse setTurnAroundEffekt.! !

FeivelItem subclass: #FeivelSlowerItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelSlowerItem commentStamp: 'MKaiser 6/28/2016 14:37' prior: 0!
Item the lowers the speed of which the mouse moves.!

!FeivelSlowerItem methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/19/2016 00:18'!
initialize
	"comment stating purpose of message"
	super initialize.
	label:= 's'.
	duration := 20.
	speed := 0.5.! !

Object subclass: #FeivelMouse
	instanceVariableNames: 'game cell direction speed effektDuration speedEffekt colour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelMouse commentStamp: 'MKaiser 6/28/2016 14:38' prior: 0!
This class represents the mouse which moves through the maze, collects items and gets manupulated by them.!

!FeivelMouse methodsFor: 'gamelogic' stamp: 'Hurli 6/23/2016 14:54'!
foundCheese
	"comment stating purpose of message"

	| |
	game setGameOver! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/18/2016 17:27'!
getSpeed
	"comment stating purpose of message"

	^(speed * speedEffekt).! !

!FeivelMouse methodsFor: 'initialization' stamp: 'MKaiser 6/18/2016 17:33'!
initialize
	"comment stating purpose of message"

	|  |
	direction := 'e'.
	speed := 1.
	speedEffekt := 1.
	effektDuration := 0.! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'PaulM 6/27/2016 16:20'!
move
	| c |
	self processDuration.
	(direction = 'n') ifTrue: [ 
		c := game getCellAt: cell getCoordinates x-1 at: cell getCoordinates y. 
		(c isOn not) ifTrue: [
			direction:= 'w'. 
			game moveMouseFrom: cell to: c in: colour. 
			^cell := c.]  
		ifFalse: [ 
			direction:= 'e'.
			^self move. ]
	]. 
	(direction = 'e') ifTrue: [ 
	 	c := game getCellAt: cell getCoordinates x at: cell getCoordinates y-1. 
		(c isOn not) ifTrue: [
			direction:= 'n'. 
			game moveMouseFrom: cell to: c in: colour. 
			^cell := c.]  
		ifFalse: [ 
			direction:= 's'.
			^self move. ]
	].
	(direction = 's') ifTrue: [ 
	 c := game getCellAt: cell getCoordinates x+1 at: cell getCoordinates y. 
		(c isOn not) ifTrue: [
			direction:= 'e'. 
			game moveMouseFrom: cell to: c in: colour. 
			^cell := c.]  
		ifFalse: [ 
			direction:= 'w'.
			^self move. ]
	].
	(direction = 'w') ifTrue: [ 
	 c := game getCellAt: cell getCoordinates x at: cell getCoordinates y+1. 
		(c isOn not) ifTrue: [
			direction:= 's'. 
			game moveMouseFrom: cell to: c in: colour. 
			^cell := c.]  
		ifFalse: [ 
			direction:= 'n'.
			^self move. ]
	].! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/18/2016 14:47'!
pickupItem
	"comment stating purpose of message"

	| item |
	item := cell getItem.
	item takeEffekt: self.
	! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/19/2016 00:17'!
processDuration
	"comment stating purpose of message"

	effektDuration > 0
		ifTrue: [ effektDuration := effektDuration - (1/speedEffekt) ]
		ifFalse: [ effektDuration := 0. speedEffekt := 1 ].! !

!FeivelMouse methodsFor: 'initialization' stamp: 'PaulM 6/27/2016 16:09'!
setColour: c
	"Set colour of mouse character"

	colour := c! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/18/2016 14:48'!
setEffektDuration: dur
	"comment stating purpose of message"

	effektDuration := dur.! !

!FeivelMouse methodsFor: 'initialization' stamp: 'MKaiser 6/2/2016 16:46'!
setGame: g
	"comment stating purpose of message"
	game := g.! !

!FeivelMouse methodsFor: 'initialization' stamp: 'MKaiser 6/2/2016 16:45'!
setPosition: coords
	"comment stating purpose of message"

	|  |
	cell := game getCellAt: coords x at: coords y.! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/18/2016 17:12'!
setSpeedEffekt: newSpeedEffekt for: duration
	"comment stating purpose of message"

	speedEffekt := newSpeedEffekt.
	effektDuration := duration.! !

!FeivelMouse methodsFor: 'gamelogic' stamp: 'MKaiser 6/18/2016 14:53'!
setTurnAroundEffekt
	"comment stating purpose of message"

	| newDirection |
	newDirection := 'n'.
	direction = 'n' ifTrue: [ newDirection := 's' ].
	direction = 'e' ifTrue: [ newDirection := 'w' ].
	direction = 's' ifTrue: [ newDirection := 'n' ].
	direction = 'w' ifTrue: [ newDirection := 'e' ].
	direction := newDirection .! !

Object subclass: #FeivelPlayer
	instanceVariableNames: 'pos color game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelPlayer commentStamp: 'MKaiser 6/28/2016 14:45' prior: 0!
Player Class handles keyboard input and droping of items!

!FeivelPlayer methodsFor: 'moves' stamp: 'PaulM 6/27/2016 18:29'!
move: direction
	"comment stating purpose of message"

	|cell|
	cell:= game getCellAt: pos x at: pos y.
	cell clearColours.
	pos := pos + direction.
	cell:= game getCellAt: pos x at: pos y.
	cell borderColor: color.! !

!FeivelPlayer methodsFor: 'moves' stamp: 'MKaiser 6/18/2016 18:08'!
moveDown
	"comment stating purpose of message"

	pos y < 50 
		ifTrue: [ self move: (0@1). ].
! !

!FeivelPlayer methodsFor: 'moves' stamp: 'MKaiser 6/18/2016 18:08'!
moveLeft
	"comment stating purpose of message"

	pos x > 1 
		ifTrue: [ self move: (-1@0).]! !

!FeivelPlayer methodsFor: 'moves' stamp: 'MKaiser 6/18/2016 18:08'!
moveRight
	"comment stating purpose of message"

	pos x < 50
		ifTrue: [ self move: (1@0).]! !

!FeivelPlayer methodsFor: 'moves' stamp: 'MKaiser 6/18/2016 18:09'!
moveUp
	"comment stating purpose of message"

	pos y > 1 
		ifTrue: [ self move: (0@(-1)).]! !

!FeivelPlayer methodsFor: 'moves' stamp: 'MKaiser 6/18/2016 16:46'!
putItem: item
	"comment stating purpose of message"

	|cell|
	cell := game getCellAt: pos x at: pos y.
	cell putItem: item.! !

!FeivelPlayer methodsFor: 'setter' stamp: 'MKaiser 6/18/2016 12:11'!
setColor: newColor
	"comment stating purpose of message"

	color := newColor! !

!FeivelPlayer methodsFor: 'setter' stamp: 'MKaiser 6/18/2016 12:13'!
setGame: newGame
	"comment stating purpose of message"

	game := newGame.! !

!FeivelPlayer methodsFor: 'setter' stamp: 'MKaiser 6/18/2016 12:12'!
setPosition: newPosition
	"comment stating purpose of message"

	pos := newPosition.	! !

!FeivelPlayer methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 12:21'!
show
	"show initial position"

	|cell |
	cell:= game getCellAt: pos x at: pos y.
	cell borderColor: color.! !

BorderedMorph subclass: #FeivelGame
	instanceVariableNames: 'cells walls player1 player2 gameOver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelGame commentStamp: 'MKaiser 6/28/2016 14:26' prior: 0!
FeivelGame - Help your mouse to get the cheese.

Main Responsiblities are the initialisation of the game.
It implements the gamelogic and wires all actors together.

Main collaborators are:
-) The Mouse: searches in the maze for the cheese.
-) The Player: can move around in the maze and drop Items to  manipulate the mouse.
-) The Items: can get collected by the mouse and have an effekt on their behaviour.

Internal Representation and Key Implementation Points.

    Instance Variables
	cells:		Representation of the maze.
	gameOver:		false till one of the mice found the cheese
	player1:		Reference to Player 1
	player2:		Reference to Player 2
	walls:		List of walls in the maze


    Implementation Points!

!FeivelGame methodsFor: 'initialization' stamp: 'Hurli 6/23/2016 15:49'!
cellsPerSide
	"The number of cells along each side of the game"
	^50! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/28/2016 14:48'!
checkSurrounding: cell with: base
	"check if the sourrounding cells are walls except the bace cell and its neighbours"

	|toCheck coords bCoords|
	coords := cell getCoordinates. 
	toCheck := self getSurroundingCells: cell.
	toCheck remove: base.
	bCoords := base getCoordinates.
	(coords x = (bCoords x)) ifTrue: [ 
		toCheck remove: (cells at: bCoords x-1 at: bCoords y). 
		toCheck remove: (cells at: bCoords x+1 at: bCoords y). 
	] ifFalse: [ 
		toCheck remove: (cells at: bCoords x at: bCoords y-1). 
		toCheck remove: (cells at: bCoords x at: bCoords y+1). 
	].
	^toCheck allSatisfy: [ :c |
		c isOn not. ].
	! !

!FeivelGame methodsFor: 'initialization' stamp: 'MKaiser 6/28/2016 14:49'!
createPlayer: position in: playerColor
	"create player on position in color"

	| player |
	
	player := FeivelPlayer new.
	player setGame: self.
	player setColor: playerColor.
	player setPosition: position.
	^player.! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/28/2016 14:49'!
createWallAt: col at: row
	"changes the cell to a wall"

	| cell |
	cell := (cells at: col at: row).
	cell turnOn.
	walls add: cell.
		! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/28/2016 14:50'!
generateMaze
	"generate maze and place cheese aproximediatly in the center (if there is a wall in the center, then the cheese is placed next to it"

	| center offsets found index pos |
	self generateMazeBorders.
	self generateMazeContent.
	
	offsets := (PointArray with: 0@0 with: 0@1 with: 1@1 with: 1@0 with: 1@(-1) with: 0@(-1) "with: (-1)@(-1) with: (-1)@0 with: (-1)@1" ).
	 
	index := 1.
	found := false.
	
	[ found ] whileFalse: [ 
		pos := ((self cellsPerSide / 2) @ (self cellsPerSide / 2)) + (offsets at: index).
		center := cells at: pos x at: pos y.
		center isOn ifFalse: [ 
			found := true.
			center putItem: FeivelCheeseItem new.
			].
		index := index + 1.
	].! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/28/2016 14:50'!
generateMazeBorders 
	"create the outer borders of the maze"

	| cols rows |
	cols := cells columnCount.
	rows := cells rowCount.
	1 to: cols do: [ :i | 
		self createWallAt: 1 at: i. 
		self createWallAt: rows at: i.
	].
	1 to: rows do: [ :i |
		self createWallAt: i at: 1.
		self createWallAt: i at: cols.
	].
	
	! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/28/2016 14:51'!
generateMazeContent
	"fill the center with walls but always leefing one cell free around it"

	| freeCells coords cell |
	[walls isNotEmpty] whileTrue: [ 
			cell :=walls atRandom. 
			freeCells := self getFreeNeighbours: cell.
			freeCells do: [ :fc | (self checkSurrounding: fc with: cell) ifFalse: [freeCells remove: fc ]].
			(freeCells size > 0) ifTrue: [ 
				coords := freeCells atRandom getCoordinates.
				self createWallAt: coords x at: coords y.
			] ifFalse: [ 
				walls remove: cell
		 	]
	].! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/2/2016 16:48'!
getCellAt: x at: y
	"comment stating purpose of message"

	|  |
	^cells at: x at: y.! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/2/2016 14:05'!
getFreeNeighbours: cell 
	"comment stating purpose of message"

	| coords neighbours i j c|
	coords := cell getCoordinates.
	i := coords x.
	j := coords y.
	neighbours := LinkedList new.
	(i > 1) ifTrue: [ 
		c := (cells at: i - 1 at:j). 
		(c isOn not) ifTrue: [ neighbours add: c ] ].
	(i < self cellsPerSide) ifTrue: [ 
		c := (cells at: i + 1 at: j). 
		(c isOn not) ifTrue: [ neighbours add: c ] ].	
	(j > 1) ifTrue: [ 
		c:= (cells at: i at: j - 1).
		(c isOn not) ifTrue: [ neighbours add: c ] ].
	(j < self cellsPerSide) ifTrue: [ 
		c:= (cells at: i at: j +1).
		(c isOn not) ifTrue: [ neighbours add: c ] ].
	^neighbours .! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'MKaiser 6/2/2016 14:08'!
getSurroundingCells: cell
	"comment stating purpose of message"

	|ret coords |
	coords := cell getCoordinates.
	ret:= LinkedList new.
	ret add: (cells at: (coords x)+1 at: (coords y)).
	ret add: (cells at: (coords x)+1 at: (coords y)+1).
	ret add: (cells at: (coords x)   at: (coords y)+1).
	ret add: (cells at: (coords x)-1 at: (coords y)+1).
	ret add: (cells at: (coords x)-1 at: (coords y)).
	ret add: (cells at: (coords x)-1 at: (coords y)-1).
	ret add: (cells at: (coords x)   at: (coords y)-1).
	ret add: (cells at: (coords x)+1 at: (coords y)-1).
	^ret.! !

!FeivelGame methodsFor: 'event handling' stamp: 'MKaiser 6/18/2016 10:49'!
handlesKeyboard: evt
	"comment stating purpose of message"
	^true! !

!FeivelGame methodsFor: 'initialization' stamp: 'MKaiser 6/28/2016 14:46'!
initialize
	"initialize game, player, mouse and start gameloop"
	|sampleCell width height n|
	super initialize.
	gameOver := false.
	n := self cellsPerSide.
	sampleCell := FeivelCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @ (height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j].
	walls := LinkedList new.
	self generateMaze.
	player1 := self createPlayer: (2@2) in: (Color green).
	player2 := self createPlayer: (n-1@2) in: (Color red).
	player1 show.
	player2 show.
	[self startMouse: 1 at: (2@2) in: (Color green).] fork.
	[self startMouse: 2 at: ((self cellsPerSide  - 1)@2) in: (Color red).] fork.
	! !

!FeivelGame methodsFor: 'event handling' stamp: 'MKaiser 6/19/2016 00:10'!
keyDown: anEvent
"Handle a key down event. ."
 | keyValue | 
    keyValue := anEvent keyValue. 

"player 1 put Item"
	keyValue = 86 "v - slower"
		ifTrue: [ player1 putItem: FeivelSlowerItem new ].
	keyValue = 66 "b - faster"
		ifTrue: [ player1 putItem: FeivelFasterItem new ].
	keyValue = 78 "n - turn around"
		ifTrue: [ player1 putItem: FeivelReturnItem new ].
"player1 movements"
	keyValue = 65  "a - left"
		ifTrue: [ player1 moveLeft ].
	keyValue = 83 "s - down"
		ifTrue: [ player1 moveDown ].
	keyValue = 68 "d - right"
		ifTrue: [ player1 moveRight ].
	keyValue = 87 "w - up"
		ifTrue: [ player1 moveUp ].	

"player 2 put Item"
	keyValue = 97 "numpad 1 - slower"
		ifTrue: [ player2 putItem: FeivelSlowerItem new ].
	keyValue = 98 "numpad 2 - faster"
		ifTrue: [ player2 putItem: FeivelFasterItem new ].
	keyValue = 99 "numpad 3 - turn around"
		ifTrue: [ player2 putItem: FeivelReturnItem new ].

"player 2 movements"
	keyValue = 30    "up arrow" 
		ifTrue: [ player2 moveUp ]. 
	keyValue = 31    "down arrow" 
		ifTrue: [ player2 moveDown ]. 
	keyValue = 29    "right arrow" 
		ifTrue: [ player2 moveRight ]. 
	keyValue = 28    "left arrow" 
		ifTrue: [ player2 moveLeft ].

	! !

!FeivelGame methodsFor: 'event handling' stamp: 'MKaiser 6/18/2016 10:50'!
mouseEnter: evt
   evt hand keyboardFocus: self ! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'PaulM 6/27/2016 18:41'!
moveMouseFrom: old to: new
	"comment stating purpose of message"

	|  |
	old clearColours.
	old clear.
	new label: 'M'.
	! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'PaulM 6/27/2016 18:42'!
moveMouseFrom: old to: new in: c
	"comment stating purpose of message"

	|  |
	old clearColours.
	old clear.
	new label: 'M'.
	new color: c.
	! !

!FeivelGame methodsFor: 'initialization' stamp: 'MKaiser 6/18/2016 15:19'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := FeivelCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c setCoordinates: i@j.
	c putItem: FeivelEmptyItem new.
	"c mouseAction: [self toggleNeighboursOfCellAt: i at: j]."
	^c ! !

!FeivelGame methodsFor: 'event handling' stamp: 'Hurli 6/23/2016 14:54'!
setGameOver
	"comment stating purpose of message"

	| |
	gameOver := true.! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'Hurli 6/23/2016 14:50'!
startMouse: name at: coord
	"comment stating purpose of message"

	| mouse|
	mouse:= FeivelMouse new.
	mouse setGame: self.
	mouse setPosition: coord.
	[ gameOver ] whileFalse: [ 
		(Delay forSeconds: (1/mouse getSpeed)) wait.
		mouse move.
		mouse pickupItem.
	].! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'PaulM 6/27/2016 16:12'!
startMouse: name at: coord in: c
	"comment stating purpose of message"

	| mouse|
	mouse:= FeivelMouse new.
	mouse setGame: self.
	mouse setPosition: coord.
	mouse setColour: c.
	[ gameOver ] whileFalse: [ 
		(Delay forSeconds: (1/mouse getSpeed)) wait.
		mouse move.
		mouse pickupItem.
	].! !

!FeivelGame methodsFor: 'gamelogic' stamp: 'KM 7/2/2014 21:34'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at:j) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j +1) toggleState].

! !

SimpleSwitchMorph subclass: #FeivelCell
	instanceVariableNames: 'mouseAction coordinates item origBorderColour origBackgroundColour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Feivel-Maze'!

!FeivelCell commentStamp: 'KM 6/30/2014 17:11' prior: 0!
Creating subclass SBECell!

!FeivelCell methodsFor: 'initialization' stamp: 'PaulM 6/27/2016 18:35'!
clear
	"comment stating purpose of message"

	self label: ''.
	
	
	! !

!FeivelCell methodsFor: 'initialization' stamp: 'PaulM 6/27/2016 18:35'!
clearColours
	self isOn ifTrue: 
			[ self color: onColor. self borderColor: #inset. ] 
		ifFalse: 
			[ self color: origBackgroundColour. self borderColor: #raised. ].! !

!FeivelCell methodsFor: 'accessing' stamp: 'MKaiser 6/18/2016 14:37'!
getCoordinates
	"comment stating purpose of message"

	^coordinates.! !

!FeivelCell methodsFor: 'accessing' stamp: 'MKaiser 6/18/2016 14:45'!
getItem
	"comment stating purpose of message"

	| i |
	i := item.
	item := FeivelEmptyItem new.
	^i.! !

!FeivelCell methodsFor: 'initialization' stamp: 'PaulM 6/27/2016 16:29'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
	origBorderColour := self borderColor.
	origBackgroundColour := self color.! !

!FeivelCell methodsFor: 'initialization' stamp: 'MKaiser 6/18/2016 17:26'!
label: l
	"comment stating purpose of message"

	super label: l.
	self width: 16.
	self height: 16.! !

!FeivelCell methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:40'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!FeivelCell methodsFor: 'as yet unclassified' stamp: 'MKaiser 6/18/2016 17:40'!
mouseUp: anEvent
	mouseAction value! !

!FeivelCell methodsFor: 'accessing' stamp: 'Hurli 6/23/2016 15:51'!
putItem: newItem
	"comment stating purpose of message"
	
	self isOn ifFalse:[
		item := newItem.
	self label: (item getLabel)
	].
	! !

!FeivelCell methodsFor: 'initialization' stamp: 'MKaiser 6/2/2016 11:49'!
setCoordinates: coords
	"comment stating purpose of message"

	| |
	coordinates := coords! !
